/*!
 * iOS SDK
 *
 * Tencent is pleased to support the open source community by making
 * Hippy available.
 *
 * Copyright (C) 2019 THL A29 Limited, a Tencent company.
 * All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 * @brief Devtools CSS props define
 */
#import <Foundation/Foundation.h>
#import "HippyDefines.h"

HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropOverFlow;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropCollapsable;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropJustifyContent;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropDisplay;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropPosition;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropZIndex;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropOpacity;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropFontSize;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropLineHeight;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropLetterSpacing;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropFontWeight;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropFontStyle;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropBackgroundSize;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropBackgroundPositionX;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropBackgroundPositionY;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropBackgroundColor;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropTextAlign;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropResizeMode;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropColor;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropTextShadowColor;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropTextDecorationColor;

#pragma mark - Rect
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropLeft;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropTop;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropRight;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropBottom;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropWidth;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropHeight;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropMinWidth;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropMaxWidth;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropMinHeight;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropMaxHeight;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropCenter;

#pragma mark - Flex
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropFlex;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropFlexGrow;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropFlexShrink;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropFlexBasis;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropFlexDirection;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropFlexWrap;

#pragma mark - Align
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropAlignItems;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropAlignSelf;

#pragma mark - Border
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropBorder;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropBorderWidth;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropBorderLeftWidth;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropBorderTopWidth;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropBorderRightWidth;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropBorderBottomWidth;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropBorderColor;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropBorderLeftColor;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropBorderTopColor;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropBorderRightColor;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropBorderBottomColor;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropBorderStyle;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropBorderRadius;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropBorderTopLeftRadius;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropBorderTopRightRadius;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropBorderBottomLeftRadius;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropBorderBottomRightRadius;

#pragma mark - Padding
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropPadding;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropPaddingLeft;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropPaddingTop;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropPaddingRight;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropPaddingBottom;

#pragma mark - Margin
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropMargin;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropMarginLeft;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropMarginTop;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropMarginRight;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropMarginBottom;

#pragma mark - Shadow
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropShadowColor;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropShadowOffset;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropShadowOffsetX;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropShadowOffsetY;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropShadowOpacity;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropShadowRadius;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropShadowSpread;

#pragma mark - Props Value General
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropValueFlexStart;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropValueFlexEnd;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropValueStretch;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropValueBaseline;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropValueAuto;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropValueNormal;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropValueItalic;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropValueBold;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropValueContain;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropValueCover;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropValueRepeat;

#pragma mark - Props Value Display
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropValueDisplayFlex;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropValueDisplayNone;

#pragma mark - Props Value Flex Direction
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropValueColumn;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropValueColumnReverse;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropValueRow;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropValueRowReverse;

#pragma mark - Props Value Flex Wrap
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropValueNowrap;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropValueWrap;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropValueWrapReverse;

#pragma mark - Props Value Justify content
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropValueSpaceBetween;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropValueSpaceAround;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropValueSpaceEvenly;

#pragma mark - Props Value OverFlow
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropValueHidden;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropValueVisible;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropValueScroll;

#pragma mark - Props Value Position
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropValueRelative;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropValueAbsolute;

#pragma mark - Props Value Background Size
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropValueBackgroundSizeFit;

#pragma mark - Props Value Font Weight
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropValueFontWeight100;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropValueFontWeight200;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropValueFontWeight300;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropValueFontWeight400;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropValueFontWeight500;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropValueFontWeight600;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropValueFontWeight700;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropValueFontWeight800;
HIPPY_EXTERN NSString *const HippyDevtoolsCSSPropValueFontWeight900;

